## signify-osx-1.4.tar.gz

=== Makefile ===
PREFIX= /usr/local
BINDIR= ${PREFIX}/bin
MANDIR= ${PREFIX}/share/man

CVSROOT= anoncvs@anoncvs.openbsd.org:/cvs
#CVSROOT= anoncvs@anoncvs3.usa.openbsd.org:/cvs

### sources from upstream

SRCS+= src/lib/libc/crypt/blowfish.c
SRCS+= src/lib/libc/hash/sha2.c
SRCS+= src/lib/libc/net/base64.c
SRCS+= src/lib/libc/string/explicit_bzero.c
SRCS+= src/lib/libutil/bcrypt_pbkdf.c
SRCS+= src/lib/libutil/ohash.c
SRCS+= src/usr.bin/signify/crypto_api.c
SRCS+= src/usr.bin/signify/fe25519.c
SRCS+= src/usr.bin/signify/mod_ed25519.c
SRCS+= src/usr.bin/signify/mod_ge25519.c
SRCS+= src/usr.bin/signify/signify.c
SRCS+= src/usr.bin/signify/sc25519.c
SRCS+= src/usr.bin/signify/zsig.c

INCL+= src/include/blf.h
INCL+= src/include/sha2.h
INCL+= src/lib/libutil/ohash.h
INCL+= src/lib/libutil/util.h # only for bcrypt_pbkdf decl
INCL+= src/usr.bin/signify/crypto_api.h
INCL+= src/usr.bin/signify/fe25519.h
INCL+= src/usr.bin/signify/ge25519.h
INCL+= src/usr.bin/signify/ge25519_base.data
INCL+= src/usr.bin/signify/sc25519.h
INCL+= src/usr.bin/signify/signify.h

MAN= src/usr.bin/signify/signify.1

FETCH_ONLY+= src/etc/signify # keys
FETCH_ONLY+= src/lib/libc/hash/helper.c # src of generated files
FETCH_ONLY+= src/regress/lib/libc/explicit_bzero
FETCH_ONLY+= src/regress/usr.bin/signify

FROM_CVS+= ${SRCS} ${INCL} ${MAN} ${FETCH_ONLY}

### local files

HASH_HELPERS+= src/lib/libc/hash/sha256hl.c
HASH_HELPERS+= src/lib/libc/hash/sha512hl.c
HASH_HELPERS+= src/lib/libc/hash/sha512_256hl.c

LOCAL_SRCS+= ${HASH_HELPERS}
LOCAL_SRCS+= hashaliases.c
LOCAL_SRCS+= freezero.c

### build cfg

CFLAGS+= -Isrc/include
CFLAGS+= -Isrc/lib/libutil
CFLAGS+= -include missing.h
CFLAGS+= '-DDEF_WEAK(a)=asm("")'
CFLAGS+= '-DMAKE_CLONE(a,b)=asm("")'
CFLAGS+= '-Dpledge(a,b)=(0)'
CFLAGS+= -Wall -Wextra
CFLAGS+= -Wno-pointer-sign
CFLAGS+= -Wno-sign-compare
CFLAGS+= -Wno-unused-parameter

### targets

.PHONY: fetch hash-helpers clean install check test up check-updates ls

signify: ${LOCAL_SRCS} ${SRCS} ${INCL}
	${CC} ${CFLAGS} -o $@ ${SRCS} ${LOCAL_SRCS}
	cp src/usr.bin/signify/signify.1 .

hash-helpers: ${HASH_HELPERS}

src/lib/libc/hash/sha256hl.c: src/lib/libc/hash/helper.c
	sed -e 's/hashinc/sha2.h/g' \
	    -e 's/HASH/SHA256/g' \
	    -e 's/SHA[0-9][0-9][0-9]_CTX/SHA2_CTX/g' $< > $@

src/lib/libc/hash/sha512hl.c: src/lib/libc/hash/helper.c
	sed -e 's/hashinc/sha2.h/g' \
	    -e 's/HASH/SHA512/g' \
	    -e 's/SHA[0-9][0-9][0-9]_CTX/SHA2_CTX/g' $< > $@

src/lib/libc/hash/sha512_256hl.c: src/lib/libc/hash/helper.c
	sed -e 's/hashinc/sha2.h/g' \
	    -e 's/HASH/SHA512_256/g' \
	    -e 's/SHA512_256_CTX/SHA2_CTX/g' $< > $@

src/lib/libc/hash/helper.c:
	$(error Missing source files... Maybe you want to `make fetch`?)

fetch:
	# Fetch the sources via CVS.
	cvs -qd ${CVSROOT} get -P ${FROM_CVS}
	# Don't keep CVS Root files around. All they do is cause false-positives
	# for change detection when fetching from different CVS mirrors.
	find src -name Root -exec rm {} +

install: signify
	install -d ${BINDIR} ${MANDIR}/man1
	install -Ss -m 755 signify ${BINDIR}
	install -S -m 644 signify.1 ${MANDIR}/man1


### regression test targets

REGRESS_BZ_SRCS=  src/lib/libc/string/explicit_bzero.c
REGRESS_BZ_SRCS+= src/regress/lib/libc/explicit_bzero/explicit_bzero.c
explicit_bzero: ${REGRESS_BZ_SRCS}
	${CC} ${CFLAGS} -o $@ ${REGRESS_BZ_SRCS}

check: test

test: signify explicit_bzero
	@sh ./regress.sh


### syncing with upstream

up: check-updates

check-updates:
	@(cd src && CVS_RSH=ssh cvs -qn up 2>&1 \
	    | (grep -v '^? ' || echo 'Up to date!'))


### misc

ls:
	@echo $(FROM_CVS:src/%=%)

clean:
	rm -rf signify signify.1 test-results explicit_bzero

=== Portfile ===
# -*- coding: utf-8; mode: tcl; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*- vim:fenc=utf-8:ft=tcl:et:sw=4:ts=4:sts=4
# $Id$

PortSystem          1.0
PortGroup           github 1.0

github.setup        jpouellet signify-osx 1.1
name                signify
categories          security
license             ISC
platforms           darwin
maintainers         vt.edu:jpo
description         cryptographically sign and verify files
long_description    The signify utility creates and verifies cryptographic \
                    signatures. A signature verifies the integrity of a message.
homepage            https://man.openbsd.org/signify.1

checksums           rmd160  a855549d6b5022c8e4bc374a4ca85b7764473df8 \
                    sha256  5b730763887554eeade766179548a941085e12f48ef3c1542553de0b5c0a3de6

variant universal   {}

use_configure       no

build.target        signify
build.args-append   CC="${configure.cc} [get_canonical_archflags cc]"

destroot.args       PREFIX="${destroot}${prefix}"

test.run            yes
